#include "Common/StdAfx.h"
#include "Audio.h"
#include "Compress.h"
#include "Graphics.h"
#include "Kernel.h"
#ifndef NO_PARSER
#include "Parse.h"
#endif
#include "Socket.h"
#include "../RegCode.h"
#include "../Strings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSprite *editor;

#undef TRIAL_MODE

int fullsc_tmp;

void CPieterApp::ShowCoreMenu (void) {
    unsigned i, j, x, x2, y, t, bp;
    char     buf [500];

    struct CoreBtn {
        signed   x,
                 y;
        unsigned tag; }
        btn [] = { {    0, -250, 0,             },
                   {    0,  250, 0,             },
                   { -320, -100, Str_Cfg_Music, },
                   { -320,    0, Str_Cfg_Sound, },
                   { -320,  100, Str_Cfg_Vol,   },
                   //{  320,  100, Str_Cfg_Full,  },
                   {  320,    0, Str_Cfg_Detl,  },
                   {  320, -100, Str_Cfg_Speed, },
                   {  320,  100, Str_Cfg_Done   } };

    static unsigned line        = 0,
                    linex       = 0,
                    doregcode   = 0,
                    core_loaded = 0,
                    setgray     = 1,
                    bootmsg     = 0,
                    animcnt     = 0;

    #ifdef TRIAL_MODE
    static unsigned n_jpeg      = 0,
                    n_midi      = 0,
                    n_wave      = 0;
    #endif

    #ifndef NO_PARSER
    char            c;
    int             edline;
    FILE            *file;
    static unsigned pos         = 0,
                    ypos        = 0,
                    selpos      = 0,
                    insert      = 1,
                    animstate   = 0,
                    entertext   = 0,
                    findnow     = 0,
                    modified    = 0,
                    oldmouse    = 0;
    static char     clipboard [1000] = { 0 },
                    textbox   [128]  = { 0 },
                    findbuf   [128]  = { 0 },
                    repbuf    [128]  = { 0 };
    #endif

    if (core_loaded == 0) {
        setgray = 1;
        fullsc_tmp = Screen.fullscreen;
        HandleCoreMenu (true);
        if (coremenu <= Core_Console) {
            if (coremenu == Core_Console) {
                ChangeDirectory (HomeDir);
                if (pack.ReadBufferPure (ErrorFile) != 0) {
                    coremenu = 0;
                    return;
                }
                pack.SeekTo (pack.textsize);
                pack.WriteB ('\n');
                pack.WriteB ('*');
                line  = 99999;
                linex = 99999;
            } else if (coremenu == Core_PackBuffer) {
                pack.SeekTo (pack.textsize);
                pack.WriteB ('\n');
                pack.WriteB ('*');
            } else if (MediaLib == NULL) {
                ChangeDirectory (HomeDir);
                pack.ReadBufferPure (StrTable[Str_BaseHelp]);
            } else {
                i = MediaRef[offset_help + coremenu];
                if (i == 0) {
                    corekey = VK_ESCAPE;
                } else if (i & ALTLIB) {
                    if (AltLib == NULL) {
                        corekey = VK_ESCAPE;
                    } else {
                        fseek (AltLib, i ^ ALTLIB, SEEK_SET);
                        pack.ReadBuffer (AltLib);
                    }
                } else {
                    fseek (MediaLib, i, SEEK_SET);
                    pack.ReadBuffer ();
                }
            }
        }
        if (coremenu == Core_Register) theApp.regcode  = 0;
        core_loaded = 1;
        //Screen.fade = true;
    }

    switch (coremenu) {


        /************************ Configuration panel ***********************/
        case Core_Configure:
            x = ((Screen.winysize * 4 / 3) - 480) / 2, 
            y = (Screen.winysize - 360) / 2;
            if (Screen.LoadJpeg (0, false)) {
                editor->BlitTiled (0, 0, 0, 380, Screen.winxsize, Screen.winysize, 64, 64);
                if (setgray) {
                    /*Screen.Lock    (Screen.jpeg);
                    Screen.PutGray (0, 0, Screen.jpeg->xsize, Screen.jpeg->ysize, 0);
                    Screen.Unlock  ();*/
                    setgray = false;
                }
                Screen.jpeg->Blit (x, y, 0, 0, 480, 360);
                /*Screen.PutRect    (0, 0, Screen.winxsize, y, 0);
                Screen.PutRect    (0, Screen.winysize - y, Screen.winxsize, Screen.winysize, 0);
                Screen.PutRect    (0, y, x, Screen.winysize - y, 0);
                Screen.PutRect    (Screen.winxsize - x, y, Screen.winxsize, Screen.winysize - y, 0);*/
            } else {
                editor->BlitTiled (0, 0, 0, 380, Screen.winxsize, Screen.winysize, 64, 64);
                //Screen.PutRect (0, 0, Screen.winxsize, Screen.winysize, 0);
            }
            for (i=0; i<sizeof (btn) / sizeof (CoreBtn); i++) {
                x = (Screen.winxsize / 2) + btn[i].x;
                y = (Screen.winysize / 2) + btn[i].y;
                switch (i) {
                    case 0: Screen.PutTextBox (0, y, Screen.winxsize, Txt_Center, AppName);
                            Screen.PutTextBox (0, y + 30, Screen.winxsize, Txt_Center | Txt_AltFont, VerName);
                            continue;
                    case 1: if (bootmsg) {
                                x2 = Str_Cfg_Boot;
                                if ((Screen.animstate & 0x30) != 0)
                                    Screen.PutTextBox (0, y, Screen.winxsize, Txt_Center | Txt_AltFont, StrTable[x2]);
                            }
                            continue;
                }
                //Screen.Lock (Screen.back);
                x2 = 0;
                t  = 0;
                if (corekey - StrTable[btn[i].tag][0] == 0) t = 1;
                else if (Screen.mousex >= x - 64 && Screen.mousex <= x + 64
                &&       Screen.mousey > y       && Screen.mousey <  y + 20) t = 2;
                if (t) {
                    /*for (x2=0; x2<128; x2++)
                        Screen.PutLine (x - 59 + x2, y, x - 69 + x2, y + 20, 0x00ff00 + 0x01fe00 * x2);
                    Screen.PutLine (x - 59, y -  1, x + 69, y -  1, 0xffffff);
                    Screen.PutLine (x - 69, y + 21, x + 58, y + 21, 0xffffff);
                    Screen.PutLine (x - 59, y,      x - 69, y + 20, 0xffffff);
                    Screen.PutLine (x + 69, y,      x + 59, y + 20, 0xffffff);*/
                    editor->Blit (x - 59, y, 320, 380, 128, 20);
                    if (t == 1) t = VE_LeftClick;
                    else        t = coremouse;
                } else {
                    editor->Blit (x - 59, y, 320, 340, 128, 20);
                    //for (x2=0; x2<128; x2++)
                        //Screen.PutLine (x - 59 + x2, y, x - 69 + x2, y + 20, 0x0030af + 0x0000ff * x2);
                }
                //Screen.Unlock ();
                x2 = Str_Cfg_Off;
                switch (btn[i].tag) {
                    case Str_Cfg_Music: if (t) Audio.music_on = !Audio.music_on;
                                        if (Audio.music_on) x2 = Str_Cfg_On;
                                        else Audio.Suspend ();
                                        break;
                    case Str_Cfg_Sound: if (t) {
                                            Audio.sound_on = !Audio.sound_on;
                                            Audio.Sound (1);
                                        }
                                        if (Audio.sound_on)  x2 = Str_Cfg_On; break;
                    /*case Str_Cfg_Full:  if (t) {
                                            fullsc_tmp = !fullsc_tmp;
                                            bootmsg = !bootmsg;
                                        }
                                        if (fullsc_tmp) x2 = Str_Cfg_On; break;*/
                    case Str_Cfg_Detl:  if (t) detailmode = !detailmode;
                                        if (detailmode)   x2 = Str_Cfg_On; break;
                    case Str_Cfg_Vol:   x2 = Audio.volume;
                                        if (t == VE_LeftClick)  Audio.SetVolume ((x2 + 1) % 10);
                                        if (t == VE_RightClick) Audio.SetVolume ((x2 + 9) % 10);
                                        if (t) Audio.Sound (1);
                                        break;
                    case Str_Cfg_Speed: x2 = try_speed;
                                        if (t == VE_LeftClick)  try_speed = (x2 + 1) % 9;
                                        if (t == VE_RightClick) try_speed = (x2 + 8) % 9;
                                        break;
                    case Str_Cfg_Done:  if (t) corekey = VK_ESCAPE;
                }
                if (x2 > 10) sprintf (buf, StrTable[btn[i].tag], StrTable[x2]);
                else         sprintf (buf, StrTable[btn[i].tag], x2 + 1);
                Screen.PutTextBox (x - 64, y + 5, x + 64, Txt_Center | Txt_AltFont, buf);
            }
            if (corekey == VK_ESCAPE || corekey == VK_RETURN) {
                if (CfgOpen (true)) {
                    CfgWrite ("Sound",  MkStr (Audio.sound_on  != 0));
                    CfgWrite ("Music",  MkStr (Audio.music_on  != 0));
                    CfgWrite ("Volume", MkStr (Audio.volume));
                    CfgWrite ("HiRes",  MkStr (Screen.hires    != 0));
                    //CfgWrite ("FullScr",MkStr (fullsc_tmp      != 0));
                    CfgWrite ("Detail", MkStr (detailmode      != 0));
                    CfgWrite ("Speed",  MkStr (try_speed));
                    CfgClose ();
                }
            }
            break;



        /************************ Registration screen ***********************/
        case Core_Register:
            if (Screen.LoadJpeg (2, false)) {
                if (setgray) {
                    /*Screen.Lock    (Screen.jpeg);
                    Screen.PutGray (0, 0, Screen.jpeg->xsize, Screen.jpeg->ysize, 0);
                    Screen.Unlock  ();*/
                    setgray = false;
                }
                Screen.jpeg->Blit (0, 0, 0, 0, Screen.winxsize, Screen.winysize);
            } else {
                //Screen.PutRect (0, 0, Screen.winxsize, Screen.winysize, 0);
            }
            i = (Screen.winxsize / 2) - 150;
            j = (Screen.winysize / 2) - 110;
            /*Screen.Lock (Screen.back);
            Screen.PutEdge (i, j, i + 300, j + 220, 0xffffff);
            Screen.PutEdge (i - 5, j - 5, i + 305, j + 225, 0xcccccc);
            Screen.PutEdge (i - 10, j - 10, i + 310, j + 230, 0x999999);
            Screen.Unlock ();*/
            if (doregcode == 0) doregcode = 1;
            Screen.PutTextBox (i, j +  10, i + 300, Txt_Center, StrTable[Str_EnterReg]);
            sprintf (buf, "%s%s%s", StrTable [Str_RegTxt1], StrTable [Str_RegTxt2], StrTable [Str_RegTxt3]);
            Screen.PutTextBox (i + 10, j +  40, i + 300, Txt_AltFont | Txt_WordBreak, buf);
            sprintf (buf, "%s%s%d", StrTable[Str_RegC1], StrTable[Str_RegC2], theApp.usercode);
            Screen.PutTextBox (i + 10, j + 170, i + 300, Txt_AltFont | Txt_WordBreak, buf);
            if (doregcode > 0 && doregcode < 10) {
                if (doregcode == 1) sprintf (buf, "_");
                else                sprintf (buf, "%d_", theApp.regcode);
                for (x=0; buf[x]; x++);
                animcnt ++;
                if ((animcnt & 0xc) == 0) buf[x - 1] = ' ';
                Screen.PutTextBox (i, j + 130, i + 300, Txt_Center,  buf);
            } else {
                doregcode ++;
                IsRegistered (x);
                if (x) {
                    if (doregcode == 0) corekey = VK_ESCAPE;
                    Screen.PutTextBox (i, j + 130, i + 300, Txt_Center, StrTable[Str_RightReg]);
                } else {
                    if (doregcode == 0) {
                        theApp.regcode = 0;
                        doregcode      = 1;
                    }
                    Screen.PutTextBox (i, j + 130, i + 300, Txt_Center, StrTable[Str_WrongReg]);
                }
                break;
            }
            if (coremouse == VE_RightClick) corekey = VK_ESCAPE;
            if (doregcode >= 1 && doregcode < 8) {
                corekey = theApp.GetNumpad (corekey);
                if (corekey >= '0' && corekey <= '9') i = corekey - '0';
                else if (corekey >= VK_NUMPAD0 && corekey <= VK_NUMPAD9) i = corekey - VK_NUMPAD0;
                if (i < 10) {
                    theApp.regcode = (10 * theApp.regcode) + i;
                    doregcode ++;
                }
            }
            switch (corekey) {
                case VK_BACK:
                    if (doregcode > 1) {
                        doregcode --;
                        theApp.regcode /= 10;
                    }
                    break;
                case VK_ESCAPE:
                    theApp.regcode = 0;
                    doregcode      = 0;
                    break;
                case VK_RETURN:
                    if (doregcode > 0 && doregcode <= 8) {
                        doregcode -= 208;
                        IsRegistered (i);
                        if (i) {
                            Audio.Sound (1);
                        } else {
                            Audio.Sound (2);
                            theApp.regcode = 0;
                        }
                        if (theApp.CfgOpen (true)) {
                            theApp.CfgWrite ("Regcode", MkStr (theApp.regcode));
                            theApp.CfgClose ();
                        }
                    }
                    break;
            }
            break;



        /*********************** Image / Sound Gallery **********************/
        #ifdef TRIAL_MODE
        case Core_Gallery:
            if (Screen.LoadJpeg (n_jpeg, false)) {
                x = Screen.jpeg->xsize;
                y = Screen.jpeg->ysize;
                if (x > Screen.winxsize) x = Screen.winxsize;
                if (y > Screen.winysize) y = Screen.winysize;
                Screen.jpeg->Blit (0, 0, 0, 0, x, y);
                Screen.PutRect    (x, 0, Screen.winxsize, Screen.winysize, 0);
                Screen.PutRect    (0, y, x,               Screen.winysize, 0);
            } else {
                Screen.PutRect    (0, 0, Screen.winxsize, Screen.winysize, 0);
            }
            Audio.Music (n_midi);
            switch (corekey) {
                case VK_UP:    n_jpeg = (n_jpeg + 1) % (Audio.offset_midi - Screen.offset_jpeg);
                               break;
                case VK_DOWN:  if (n_jpeg == 0) n_jpeg = Audio.offset_midi - Screen.offset_jpeg - 1;
                               else n_jpeg --;
                               break;
                case VK_LEFT:  if (n_midi == 0) n_midi = Audio.offset_wave - Audio.offset_midi;
                               else n_midi --;
                               break;
                case VK_RIGHT: n_midi = (n_midi + 1) % (Audio.offset_wave - Audio.offset_midi);
                               break;
                case VK_PRIOR: if (n_wave == 0) n_wave = offset_help - Audio.offset_wave;
                               else n_wave --;
                               Audio.Sound (n_wave);
                               break;
                case VK_NEXT:  n_wave = (n_wave + 1) % (offset_help - Audio.offset_wave);
                               Audio.Sound (n_wave);
                               break;
            }
            break;
        #endif



        /**************************** Text editor ***************************/
        #ifndef NO_PARSER
        case Core_Editor:
            if (script == NULL || scrsize == 0) coremenu = 0;
            edline = -1;
            Screen.PutRect (0, 0, Screen.winxsize, Screen.winysize, 0x777777);
            Screen.PutRect (10, 10, 690, 560, 0);
            Screen.Lock    (Screen.back);
            Screen.PutEdge (10, 10, 690, 560, 0xffffff);
            Screen.Unlock  ();
            animstate ++;

            #define DrawCurs() \
            if (i == pos && (animstate & 0x10) && entertext == 0) { \
                Screen.Lock (Screen.back); \
                if (insert) Screen.PutEdge (x * 11 + 13, y * 20 + 15, x * 11 + 14, y * 20 + 32, 0xffffff); \
                else        Screen.PutEdge (x * 11 + 14, y * 20 + 15, x * 11 + 26, y * 20 + 32, 0xffffff); \
                Screen.Unlock (); \
            }

            y = 0 - ypos;
            x = 0;
            for (i=0; script[i]; i++) {
                c = script[i];
                if (c >= ' ') {
                    if ((signed) y >= 0) {
                        if (i == pos) edline = ypos + y;
                        if ((i >= pos && i < selpos) || (i >= selpos && i < pos))
                            Screen.PutRect (x * 11 + 15, y * 20 + 14, x * 11 + 26, y * 20 + 34, 0x0088ff);
                        Screen.font->BlitTr (x * 11 + 15, y * 20 + 15, 20 * (c & 15), 20 * (c / 16) + 517, 11, 18);
                        DrawCurs ();
                    } else if (i == pos) {
                        edline = ypos + y;
                        if (y == 0xffffffff) {
                            y    = 0;
                            ypos --;
                        } else {
                            ypos -= 2;
                            y    += 2;
                        }
                    }
                    x ++;
                    if (x > 60) {
                        for (x=0; x<60; x++) {
                            if (i == x) break;
                            if (script[i - x] == ' ') {
                                script[i - x] = 0x0a;
                                return;
                            }
                        }
                        x = 0x0a;
                        for (j=i; x; j++) {
                            y = script[j];
                            script[j] = x;
                            x = y;
                        }
                        if (pos    > i) pos ++;
                        if (selpos > i) selpos ++;
                        return;
                    }
                } else {
                    if (i == pos) {
                        edline = ypos + y;
                        if ((signed) y < 0) {
                            if (y == 0xffffffff) {
                                y    = 0;
                                ypos --;
                            } else {
                                ypos -= 2;
                                y    += 2;
                            }
                        }
                    }
                    DrawCurs ();
                    if (x == 0) {
                        x = ' ';
                        for (j=i; x && j < scrsize - 1; j++) {
                            x2 = script[j];
                            script[j] = x;
                            x = x2;
                        }
                        script[j] = 0;
                        x = 1;
                        if (pos    > i) pos ++;
                        if (selpos > i) selpos ++;
                        i++;
                    }
                    x = 0;
                    y++;
                    if (y == 27) {
                        if (i < pos) {
                            if (i < pos + 60) ypos += 2;
                            else              ypos += 1;
                        }
                        break;
                    }
                }
            }
            if (pos == i) edline = ypos + y;
            if (pos > i && (signed) y < 27) {
                pos    = 0;
                selpos = 0;
                return;
            }
            if (y < 27) DrawCurs ();

            x = Screen.mousex;
            y = Screen.mousey;
            if (x > 10 && x < 690 && y > 10 && y < 560 && coremouse) {
                x = (x - 15) / 11;
                y = (y - 15) / 20;
                for (pos = 0; script[pos] && y > 0; pos ++)
                    if (script[pos] == 0x0a) y --;
                if (script[pos] == 0) {
                    for (pos--; pos > 0; pos--)
                        if (script[pos] == 0x0a) { pos ++; break; }
                }
                for (; script[pos] && x > 0; pos ++, x--)
                    if (script[pos] == 0x0a) break;
                if (oldmouse == 0) selpos = pos;
            } else if (x > 700 && y > 14 && y < 565) {
                y = (y - 14) / 29;
                if (StrTable[Str_SEC_00 + y][0] != ' ') {
                    Screen.Lock (Screen.back);
                    Screen.PutEdge (696, y * 29 + 15, 796, y * 29 + 37, 0xffffff);
                    Screen.Unlock ();
                    if (coremouse && oldmouse == 0) {
                        x = StrTable[Str_SEC_00 + y][0];
                        if (x == '?') corekey = VK_F1;
                        else {
                            corekey   =  x;
                            coreshift |= Key_Control | (Key_Control << 8);
                        }
                    }
                }
            }
            oldmouse = coremouse;
            for (i=0; i<=Str_SEC_Last - Str_SEC_00; i++) {
                Screen.PutTextBox (700, i * 29 + 20, 799, Txt_AltFont, StrTable[Str_SEC_00 + i] + 1);
            }

            if (findnow) {
                for (i=pos + 1, j=0; i != pos; i++) {
                    if (script[i] == 0) i = 0;
                    if (script[i] == findbuf[j]) {
                        j++;
                        if (findbuf[j] == 0) {
                            pos    = i - j + 1;
                            selpos = i + 1;
                            break;
                        }
                    } else j = 0;
                }
                if (repbuf[0] && findbuf[j] == 0) {
                    for (j=0; script[selpos + j]; j++)
                        script[pos + j] = script[selpos + j];
                    script[pos + j] = 0;
                    for (j=0; repbuf[j]; j++);
                    for (i=pos; script[i]; i++);
                    for (; i>=pos; i--) script[i + j] = script[i];
                    for (j=0; repbuf[j]; j++) script[pos + j] = repbuf[j];
                    pos += j;
                    selpos = pos;
                }
                findnow = 0;
                break;
            }

            if (entertext) {
                for (j=0; textbox[j]; j++);
                if (animstate & 0x10) textbox[j] = '|';
                textbox[j + 1] = 0;
                i = entertext;
                if (i == Str_SEC_09) i --;
                Screen.PutTextBox ( 15, 574, 690, Txt_AltFont, StrTable[i] + 1);
                Screen.PutTextBox (100, 574, 690, Txt_AltFont, textbox);
                textbox[j] = 0;
                switch (corekey) {
                    case VK_LEFT:
                    case VK_BACK:   textbox[j - 1] = 0; break;
                    case VK_HOME:
                    case VK_DELETE: textbox[0]     = 0; break;
                    case VK_F1:     coremenu       = 1;
                                    core_loaded    = 0; break;
                    case VK_ESCAPE: entertext      = 0;
                                    textbox[0]     = 0;
                                    corekey        = 0; break;
                    case VK_RETURN:
                        switch (entertext) {
                            case Str_SEC_05:
                                file = fopen (textbox, "rb");
                                if (file) {
                                    i = 0;
                                    c = 1;
                                    while (!feof (file) && c) {
                                        c = fgetc (file);
                                        if (c == 0x0d) c = fgetc (file);
                                        if (c == 0x09) c = ' ';
                                        if ((c < 32 || c > 126) && c != 0x0a) c = 0;
                                        script[i] = c;
                                        i++;
                                    }
                                    script[i] = 0;
                                    fclose (file);
                                }
                                entertext = 0;
                                break;
                            case Str_SEC_06:
                                file = fopen (textbox, "wb");
                                if (file) {
                                    for (i=0; script[i]; i++) {
                                        if (script[i] == 0x0a) fputc (0x0d, file);
                                        fputc (script[i], file);
                                    }
                                    fputc (0, file);
                                    fclose (file);
                                }
                                entertext = 0;
                                break;
                            case Str_SEC_08:
                                strcpy (findbuf, textbox);
                                repbuf[0] = 0;
                                findnow   = 1;
                                entertext = 0;
                                break;
                            case Str_SEC_09:
                                strcpy (findbuf, textbox);
                                entertext = Str_SEC_10;
                                break;
                            case Str_SEC_10:
                                strcpy (repbuf,  textbox);
                                findnow   = 1;
                                entertext = 0;
                                break;
                        }
                        textbox[0] = 0;
                        break;
                    default:
                        c = 0;
                        if ((coreshift & Key_Shift)) {
                            for (i=VK_LTR + 'A'; i<=VK_LTR + 'Z'; i++) if (corekey == i) c = i - VK_LTR;
                            for (i= 0;  i<= 9;  i++) if (corekey == i + VK_0) c =  ")!@#$%^&*("[i];
                            if (corekey == VK_COLON)      c = ':';
                            if (corekey == VK_EQUALSIGN)  c = '+';
                            if (corekey == VK_COMMA)      c = '<';
                            if (corekey == VK_MINUS)      c = '_';
                            if (corekey == VK_PERIOD)     c = '>';
                            if (corekey == VK_SLASH)      c = '?';
                            if (corekey == VK_QUOTE)      c = '"';
                            if (corekey == VK_LEFTBRACK)  c = '{';
                            if (corekey == VK_BACKSLASH)  c = '|';
                            if (corekey == VK_RIGHTBRACK) c = '}';
                            if (corekey == VK_APOSTROPHE) c = '~';
                            if (corekey == VK_BACKSLASH2) c = '|';
                        } else {
                            for (i=VK_LTR + 'A'; i<=VK_LTR + 'Z'; i++) if (corekey == i) c = i - VK_LTR + 'a' - 'A';
                            for (i= 0;  i<= 9;  i++) if (corekey == i + VK_0) c = i + '0';
                            if (corekey == VK_COLON)      c = ';';
                            if (corekey == VK_EQUALSIGN)  c = '=';
                            if (corekey == VK_COMMA)      c = ',';
                            if (corekey == VK_MINUS)      c = '-';
                            if (corekey == VK_PERIOD)     c = '.';
                            if (corekey == VK_SLASH)      c = '/';
                            if (corekey == VK_QUOTE)      c = '\'';
                            if (corekey == VK_LEFTBRACK)  c = '[';
                            if (corekey == VK_BACKSLASH)  c = '\\';
                            if (corekey == VK_RIGHTBRACK) c = ']';
                            if (corekey == VK_APOSTROPHE) c = '`';
                            if (corekey == VK_BACKSLASH2) c = '\\';
                        }
                        if (corekey == VK_ADD)      c = '+';
                        if (corekey == VK_SUBTRACT) c = '-';
                        if (corekey == VK_MULTIPLY) c = '*';
                        if (corekey == VK_DIVIDE)   c = '/';
                        if (corekey == VK_SPACE)    c = ' ';
                        if (corekey == VK_TAB)      c = ' ';
                        if (c && j < 127) textbox[j] = c;
                        corekey = 0;
                }
                break;
            }

            Screen.PutTextBox ( 15, 574, 690, Txt_AltFont,             Script.outbuf);
            Screen.PutTextBox ( 15, 574, 660, Txt_AltFont | Txt_Right, StrTable[Str_Lineno]);
            Screen.PutTextBox (660, 574, 690, Txt_AltFont | Txt_Right, MkStr (edline + 1));

            if (corekey == VK_LEFT && pos > 0) {
                pos --;
                if ((coreshift & Key_Control) && pos > 0) {
                    pos --;
                    while (pos > 0) {
                        c = script[pos];
                        if (c < 'a' || c > 'z') break;
                        pos --;
                    }
                    if (pos != 0) pos ++;
                }
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_RIGHT && script[pos]) {
                pos ++;
                if ((coreshift & Key_Control) && script[pos]) {
                    pos ++;
                    while (script[pos]) {
                        c = script[pos];
                        if (c < 'a' || c > 'z') break;
                        pos ++;
                    }
                    if (script[pos]) pos ++;
                }
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_UP && pos != 0) {
                for (i=0, pos--; pos != 0; i++, pos--) {
                    if (script[pos] < ' ') {
                        for (pos--; pos >= 0 && script[pos] >= ' '; pos--);
                        if (pos == 0) i--;
                        for (pos++; i>0; i--, pos++) if (script[pos] < ' ') break;
                        break;
                    }
                }
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_DOWN && script[pos]) {
                if (pos > 0) { pos --; i = 1; } else i = 0;
                for (; 1; i++, pos--) {
                    if (script[pos] < ' ' || pos == 0) {
                        if (pos != 0) i --;
                        for (pos++; script[pos] && script[pos] >= ' '; pos++);
                        if (script[pos]) for (pos++; i>0; i--, pos++) {
                            if (script[pos] < ' ') break;
                        }
                        break;
                    }
                }
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_PRIOR) {
                for (i=0; i<24 && pos != 0; i++)
                    for (pos--; pos > 0; pos--) if (script[pos] == 0x0a) { break; }
                if (pos) pos ++;
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_NEXT) {
                for (i=0; i<24 && script[pos] && script[pos + 1]; i++)
                    for (pos++; script[pos + 1]; pos++)
                        if (script[pos] == 0x0a) { pos ++; break; }
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_HOME) {
                if ((coreshift & Key_Control)) pos = 0;
                else {
                    for (pos--; pos > 0 && script[pos] >= ' '; pos--);
                    if (pos != 0) pos ++;
                }
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_END && script[pos]) {
                if ((coreshift & Key_Control)) {
                    for (; script[pos]; pos++); pos --;
                } else if (script[pos] >= ' ')
                    for (pos++; script[pos] >= ' '; pos++);
                if (pos > 0 && script[pos - 1] == ' ') pos --;
                if ((coreshift & Key_Shift) == 0) selpos = pos;
            }
            if (corekey == VK_F1) {
                coremenu    = 1;
                core_loaded = 0;
            }

            if ((coreshift & Key_Control)) {
                if (corekey == 'X') { corekey = VK_DELETE; coreshift |= Key_Shift | (Key_Shift << 8); }
                if (corekey == 'C') { corekey = VK_INSERT; }
                if (corekey == 'V') { corekey = VK_INSERT; coreshift |= Key_Shift | (Key_Shift << 8); }
                if (corekey == 'A') { pos = 0; for (selpos=0; script[selpos]; selpos++); }
                if (corekey == 'Q') { coremenu  = 0; }
                if (corekey == 'B') { corekey   = VK_BACK; }
                if (corekey == 'I') { entertext = Str_SEC_05; }
                if (corekey == 'E') { entertext = Str_SEC_06; }
                if (corekey == 'F') { entertext = Str_SEC_08; }
                if (corekey == 'R') { entertext = Str_SEC_09; }
                if (corekey == 'G') { findnow   = 1;          }
                if (corekey == 'T') {
                    if (Script.ReadScript (0, 0, script) == false) {
                        j = 1;
                        for (pos=0; script[pos]; pos++)
                            if (script[pos] == 0x0a) {
                                j++;
                                if (j == Script.curline) break;
                            }
                        pos ++;
                        selpos = pos;
                    }
                }
            } else {
                c = 0;
                if ((coreshift & Key_Shift)) {
                    for (i='A'; i<='Z'; i++) if (corekey - i == 0) c = i;
                    for (i=0; i<=9; i++) if (corekey - i == '0') c =  ")!@#$%^&*("[i];
                    if (corekey == VK_COLON)      c = ':';
                    if (corekey == VK_EQUALSIGN)  c = '+';
                    if (corekey == VK_COMMA)      c = '<';
                    if (corekey == VK_MINUS)      c = '_';
                    if (corekey == VK_PERIOD)     c = '>';
                    if (corekey == VK_SLASH)      c = '?';
                    if (corekey == VK_QUOTE)      c = '"';
                    if (corekey == VK_LEFTBRACK)  c = '{';
                    if (corekey == VK_BACKSLASH)  c = '|';
                    if (corekey == VK_RIGHTBRACK) c = '}';
                    if (corekey == VK_APOSTROPHE) c = '~';
                    if (corekey == VK_BACKSLASH2) c = '|';
                } else {
                    for (i='A'; i<='Z'; i++) if (corekey - i == 0) c = i + 32;
                    for (i=0; i<=9; i++) if (corekey - i == '0') c = i + '0';
                    if (corekey == VK_COLON)      c = ';';
                    if (corekey == VK_EQUALSIGN)  c = '=';
                    if (corekey == VK_COMMA)      c = ',';
                    if (corekey == VK_MINUS)      c = '-';
                    if (corekey == VK_PERIOD)     c = '.';
                    if (corekey == VK_SLASH)      c = '/';
                    if (corekey == VK_QUOTE)      c = '\'';
                    if (corekey == VK_LEFTBRACK)  c = '[';
                    if (corekey == VK_BACKSLASH)  c = '\\';
                    if (corekey == VK_RIGHTBRACK) c = ']';
                    if (corekey == VK_APOSTROPHE) c = '`';
                    if (corekey == VK_BACKSLASH2) c = '\\';
                }
                if (corekey == VK_ADD)      c = '+';
                if (corekey == VK_SUBTRACT) c = '-';
                if (corekey == VK_MULTIPLY) c = '*';
                if (corekey == VK_DIVIDE)   c = '/';
                if (corekey == VK_SPACE)    c = ' ';
                if (corekey == VK_TAB)      c = ' ';
                if (corekey == VK_RETURN)   c = 0x0a;
                if (c) {
                    if (selpos != pos) {
                        if (selpos < pos) {
                            for (j=0; script[pos + j]; j++)
                                script[selpos + j] = script[pos + j];
                            script[selpos + j] = 0;
                            pos = selpos;
                        } else {
                            for (j=0; script[selpos + j]; j++)
                                script[pos + j] = script[selpos + j];
                            script[pos + j] = 0;
                            selpos = pos;
                        }
                        x = c;
                        for (j=pos; x && j < scrsize - 1; j++) {
                            x2 = script[j];
                            script[j] = x;
                            x = x2;
                        }
                        script[j] = 0;
                        pos ++;
                    } else {
                        if (insert || script[pos] == 0) {
                            x = c;
                            for (j=pos; x && j < scrsize - 1; j++) {
                                x2 = script[j];
                                script[j] = x;
                                x = x2;
                            }
                            script[j] = 0;
                            pos ++;
                        } else script[pos++] = c;
                    }
                    if (corekey == VK_RETURN && pos > 1) {
                        for (i=pos-2; i>0; i--) if (script[i] == 0x0a) {
                            for (i++; i<pos; i++) {
                                if (script[i] != ' ') break;
                                x = ' ';
                                for (j=pos; x && j < scrsize - 1; j++) {
                                    x2 = script[j];
                                    script[j] = x;
                                    x = x2;
                                }
                                script[j] = 0;
                                pos ++;
                            }
                            break;
                        }
                    }
                    if (corekey == VK_TAB) {
                        x = ' ';
                        for (j=pos; x && j < scrsize - 1; j++) {
                            x2 = script[j];
                            script[j] = x;
                            x = x2;
                        }
                        script[j] = 0;
                        pos ++;
                    }
                    selpos   = pos;
                    modified = true;
                }
            }
            if (corekey == VK_BACK) {
                if (selpos != pos) {
                    if (selpos < pos) {
                        for (j=0; script[pos + j]; j++)
                            script[selpos + j] = script[pos + j];
                        script[selpos + j] = 0;
                        pos = selpos;
                    } else {
                        for (j=0; script[selpos + j]; j++)
                            script[pos + j] = script[selpos + j];
                        script[pos + j] = 0;
                        selpos = pos;
                    }
                } else if (pos > 0) {
                    for (j = pos - 1; script[j]; j++)
                        script[j] = script[j + 1];
                    pos --;
                    selpos = pos;
                }
                modified = true;
            }
            if (corekey == VK_DELETE) {
                if ((coreshift & Key_Shift)) {
                    if (selpos != pos) {
                        if (selpos < pos) {
                            for (j=0; j - pos + selpos != 0 && j < 999; j++)
                                clipboard[j] = script[selpos + j];
                            clipboard[j] = 0;
                            for (j=0; script[pos + j]; j++)
                                script[selpos + j] = script[pos + j];
                            script[selpos + j] = 0;
                            pos = selpos;
                        } else {
                            for (j=0; j - selpos + pos != 0 && j < 999; j++)
                                clipboard[j] = script[pos + j];
                            clipboard[j] = 0;
                            for (j=0; script[selpos + j]; j++)
                                script[pos + j] = script[selpos + j];
                            script[pos + j] = 0;
                            selpos = pos;
                        }
                    }
                } else {
                    if (selpos != pos) {
                        if (selpos < pos) {
                            for (j=0; script[pos + j]; j++)
                                script[selpos + j] = script[pos + j];
                            script[selpos + j] = 0;
                            pos = selpos;
                        } else {
                            for (j=0; script[selpos + j]; j++)
                                script[pos + j] = script[selpos + j];
                            script[pos + j] = 0;
                            selpos = pos;
                        }
                    } else {
                        for (j = pos; script[j]; j++)
                            script[j] = script[j + 1];
                    }
                }
                modified = true;
            }
            if (corekey == VK_INSERT) {
                if ((coreshift & Key_Shift)) {
                    if (selpos != pos) {
                        if (selpos < pos) {
                            for (j=0; script[pos + j]; j++)
                                script[selpos + j] = script[pos + j];
                            script[selpos + j] = 0;
                            pos = selpos;
                        } else {
                            for (j=0; script[selpos + j]; j++)
                                script[pos + j] = script[selpos + j];
                            script[pos + j] = 0;
                            selpos = pos;
                        }
                    }
                    if (clipboard[0]) {
                        for (j=0; clipboard[j]; j++);
                        for (i=pos; script[i]; i++);
                        for (; i>=pos && i>0; i--) script[i + j] = script[i];
                        for (j=0; clipboard[j]; j++) script[pos + j] = clipboard[j];
                        pos += j;
                        selpos = pos;
                    }
                } else if ((coreshift & Key_Control)) {
                    if (selpos != pos) {
                        if (selpos < pos) {
                            for (j=0; j - pos + selpos != 0 && j < 999; j++)
                                clipboard[j] = script[selpos + j];
                            clipboard[j] = 0;
                        } else {
                            for (j=0; j - selpos + pos != 0 && j < 999; j++)
                                clipboard[j] = script[pos + j];
                            clipboard[j] = 0;
                        }
                    }
                } else insert ^= 1;
                modified = true;
            }
            if (coreshift & (Key_Shift   << 8)) coreshift &= -1 ^ (Key_Shift   | (Key_Shift   << 8));
            if (coreshift & (Key_Control << 8)) coreshift &= -1 ^ (Key_Control | (Key_Control << 8));
            break;
        #endif



        /********************** Poor Text Format reader *********************/
        default:
            if (Screen.LoadJpeg (1, false)) {
                if (setgray) {
                    /*Screen.Lock    (Screen.jpeg);
                    Screen.PutGray (0, 0, Screen.jpeg->xsize, Screen.jpeg->ysize, 0);
                    Screen.Unlock  ();*/
                    setgray = false;
                }
                Screen.jpeg->Blit (0, 0, 0, 0, Screen.winxsize, Screen.winysize);
            } else {
                editor->BlitTiled (0, 0, 0, 370, Screen.winxsize, Screen.winysize, 64, 64);
            }
            if (line > linex) {
                line--;
                if (line > linex) line--;
            }
            if (line < linex) {
                line++;
                if (line < linex) line++;
            }
            pack.InitBuffer ();
            i  = 0;
            bp = 0;
            while (i != 0x0a) {
                i = pack.ReadB ();
                if (i >= ' ') {
                    buf[bp] = i;
                    if (bp < sizeof (buf) - 1) bp++;
                }
            }
            buf[bp] = 0;
            i       = 0;
            x2      = 0;
            y       = 48;
            x2      = 1;
            while (i < line) {
                x = pack.ReadB ();
                if (x2 == 1) {
                    if (x == '*') {
                        line  = i - 15;
                        linex = i - 15;
                        i     = 0;
                        i--;
                        pack.InitBuffer ();
                    } else if (x == '0') {
                        if (pack.ReadB () == '0') if (pack.ReadB () == '0') {
                            for (bp = 0; buf[bp] != ':' && buf[bp] >= ' '; bp++);
                            buf[bp] = ':';
                            bp++;
                            while (x != 0x0a) {
                                x = pack.ReadB ();
                                if (x >= ' ') {
                                    buf[bp] = x;
                                    if (bp < sizeof (buf) - 1) bp ++;
                                }
                            }
                            buf[bp] = 0;
                        }
                    } else if (x == '-') i--;
                }
                if (x == 0x0a) {
                    i++; x2 = 1;
                } else x2 = 0;
            }
            Screen.PutTextBox (20, 20, Screen.winxsize - 20, 0, buf);
            //Screen.PutRect    (20, 43, Screen.winxsize - 20, 44, 0xffffff);
            editor->BlitTiled (20, 43, 317, 405, Screen.winxsize - 40, 1, 195, 5);
            Screen.PutTextBox (20, 25, Screen.winxsize - 24, Txt_Right | Txt_AltFont, StrTable[Str_HelpScrn]);
            sprintf (buf, StrTable[Str_HelpPage], (linex / 20) + 1);
            Screen.PutTextBox (20,  9, Screen.winxsize - 24, Txt_Right | Txt_AltFont, buf);
            while (y < Screen.winysize - 30) {
                i = pack.ReadB ();
                t = 0;
                if (i == '-' || i == '*') {
                    if (y != 48) {
                        editor->BlitTiled (20, y - 1, 317, 405, Screen.winxsize - 40, 1, 195, 5);
                        y += 4;
                    }
                    if (i == '*') break;
                    do { i = pack.ReadB (); } while (i != 0x0a);
                    continue;
                }
                if (i == '<') {
                    do { i = pack.ReadB (); } while (i != 0x0a && i != '>');
                    if (i == 0x0a) continue;
                    i = pack.ReadB ();
                    if (i == 0x0d) i = pack.ReadB ();
                    if (i == 0x0a) continue;
                }
                x  = 60;
                bp = 0;
                if (i >= '0' && i <= '9') {
                    if (y > Screen.winysize - 50) break;
                    t = (i - '0') * 0x100;
                    i = pack.ReadB (); if (i >= 'a' && i <= 'f') i = (i - 'a') + '0' + 0x0a;
                    t += (i - '0') * 0x010;
                    i = pack.ReadB (); if (i >= 'a' && i <= 'f') i = (i - 'a') + '0' + 0x0a;
                    t += (i - '0');
                    if (t == 0 || t == 1) {
                        i = pack.ReadB ();
                        if (i == '0' && y != 48) {
                            editor->BlitTiled (20, y - 1, 317, 405, Screen.winxsize - 40, 1, 195, 5);
                            while (i != 0x0a) i = pack.ReadB ();
                            y += 4;
                            continue;
                        }
                        while (i != 0x0a) {
                            i = pack.ReadB ();
                            if (i >= ' ') {
                                buf[bp] = i;
                                if (bp < sizeof (buf) - 1) bp ++;
                            }
                        }
                        buf[bp] = 0;
                        Screen.PutTextBox (20, y + 6, Screen.winxsize - 20, Txt_Center, buf);
                        y += 36;
                        continue;
                    } else if (t == 0x999) {
                        Screen.PutTextBox (x + (Screen.winxsize - 800) / 2, y + 6, Screen.winxsize - 20, 0, MkStr (theApp.usercode));
                        y += 20;
                        continue;
                    } else {
                        i = HandlePTFCode (t, 20 + (Screen.winxsize - 800) / 2, y);
                        if (i) {
                            y += i;
                            continue;
                        }
                    }
                    i = pack.ReadB ();
                    x -= 4;
                    t  = 1;
                }
                x2 = x;
                while (i != 0x0a) {
                    if (i == '|') {
                        i = pack.ReadB ();
                        continue;
                    }
                    if (i == '<' && bp == 0) {
                        while (i != 0x0a && i != '>') i = pack.ReadB ();
                        if (i == '>') i = pack.ReadB ();
                        continue;
                    }
                    if (i > ' ' && i != '@' && i != '`') {
                        buf[bp] = i;
                        if (bp < sizeof (buf) - 1) bp ++;
                        if (i != '$') {
                            if (t) x2 += Screen.fontdata[i];
                            else   x2 += Screen.fontdata[i + 96];
                        }
                        i = pack.ReadB ();
                        continue;
                    }
                    if (x2 >= 780) {
                        y += 17;
                        x2 = (x2 - x) + 60;
                        x = 60;
                    }
                    buf[bp] = 0;
                    if (i == '`') x2 = ((x2 / 90) + 1) * 90;
                    if (t) {
                        Screen.PutTextBox (x + (Screen.winxsize - 800) / 2, y + 6, Screen.winxsize - 20, 0,           buf);
                        x = x2 + 8;
                    } else {
                        Screen.PutTextBox (x + (Screen.winxsize - 800) / 2, y,     Screen.winxsize - 20, Txt_AltFont, buf);
                        x = x2 + 4;
                    }
                    bp = 0;
                    i  = pack.ReadB ();
                    if (i >= '0' && i <= '9') {
                        x2 = (i - '0') * 0x100;
                        i = pack.ReadB (); if (i >= 'a' && i <= 'f') i = i - 'a' + '0' + 0x0a;
                        x2 += (i - '0') * 0x010;
                        i = pack.ReadB (); if (i >= 'a' && i <= 'f') i = i - 'a' + '0' + 0x0a;
                        x2 += (i - '0');
                        if (t) {
                            HandlePTFCode (x2, x, y);
                            x += 36;
                            t |= 2;
                        } else {
                            HandlePTFCode (x2 | 0x1000, x, y);
                            x += 16;
                        }
                        i = pack.ReadB ();
                    }
                    x2 = x;
                }
                if (t == 1) y += 29;
                else if (t) y += 36;
                else        y += 17;
            }

            if (coremouse == VE_LeftClick)  corekey = VK_NEXT;
            if (coremouse == VE_RightClick) corekey = VK_PRIOR;
            switch (corekey) {
                case VK_DOWN:   if (i != '*') linex ++;                     break;
                case VK_NEXT:
                case VK_SPACE:  if (i != '*' && line == linex) linex += 20; break;
                case VK_UP:     if (linex) linex --;                        break;
                case VK_PRIOR:  if (line == linex) {
                                    if (linex < 20) linex = 0;
                                    else linex -= 20;
                                }                                           break;
                case VK_HOME:   line = 0;     linex  = 0;                   break;
                case VK_END:    line = 99999; linex  = 99999;               break;
                case VK_RETURN: corekey = VK_ESCAPE;                        break;
            }
            break;
    }
    editor->BlitTr (Screen.mousex, Screen.mousey, 496, 160, 15, 20);
    /*Screen.Lock      (Screen.back);
    Screen.PutCircle (Screen.mousex, Screen.mousey, 10, 0xffffff);
    Screen.Unlock    ();*/
    Screen.Flip      ();

    if (corekey == VK_F8) Screen.SaveScreenshot ();
    if (corekey == VK_F10 && MediaLib == NULL) {
        runlevel = Run_Abort;
        corekey = VK_ESCAPE;
    }
    if (corekey == VK_ESCAPE) {
        coremenu    = 0;
        core_loaded = 0;
        line        = 0;
        linex       = 0;
        //Screen.fade = true;
        HandleCoreMenu (false);
    }
    corekey   = 0;
    coremouse = 0;
}
